diff --git a/toolkit/moz.configure b/toolkit/moz.configure
--- a/toolkit/moz.configure
+++ b/toolkit/moz.configure
@@ -2353,18 +2353,6 @@ with only_when(compile_environment & tar
     )
     set_config("MOZ_D3DCOMPILER_VISTA_DLL_PATH", d3d_compiler_dll.path)
 
-# Remoting protocol support
-# ==============================================================
-
-
-@depends(toolkit)
-def has_remote(toolkit):
-    if toolkit in ("gtk", "windows", "cocoa"):
-        return True
-
-
-set_config("MOZ_HAS_REMOTE", has_remote)
-set_define("MOZ_HAS_REMOTE", has_remote)
 
 # RLBox Library Sandboxing wasm support
 # ==============================================================
@@ -2900,6 +2888,26 @@ with only_when(toolkit_gtk):
         set_config("MOZ_ENABLE_DBUS", True)
         set_define("MOZ_ENABLE_DBUS", True)
 
+# Remoting protocol support
+# ==============================================================
+
+@depends(
+    toolkit,
+    depends("--enable-dbus", when=toolkit_gtk)(lambda x: x),
+    depends(wayland_headers, when=toolkit_gtk)(lambda x: x),
+    depends(x11_headers, when=toolkit_gtk)(lambda x: x),
+)
+def has_remote(toolkit, dbus, wayland, x11):
+    if toolkit in ("windows", "cocoa"):
+        return True
+    if toolkit == "gtk":
+        if not dbus and wayland and not x11:
+            return
+        return True
+
+
+set_config("MOZ_HAS_REMOTE", has_remote)
+set_define("MOZ_HAS_REMOTE", has_remote)
 
 # Necko's wifi scanner
 # ==============================================================
